=== modified file '__init__.py'
--- __init__.py	2008-04-01 10:18:53 +0000
+++ __init__.py	2008-04-16 00:00:41 +0000
@@ -383,14 +383,20 @@
     
     aliases = [ "gst" ]
     takes_args = ['PATH?']
-    takes_options = []
+    takes_options = ['revision']
 
-    def run(self, path='.'):
+    def run(self, path='.', revision=None):
         import os
         gtk = self.open_display()
         from status import StatusDialog
         (wt, wt_path) = workingtree.WorkingTree.open_containing(path)
-        status = StatusDialog(wt, wt_path)
+        
+        if revision is not None:
+            revision_id = revision[0].in_history(wt.branch).rev_id
+        else:
+            revision_id = None
+
+        status = StatusDialog(wt, wt_path, revision_id)
         status.connect("destroy", gtk.main_quit)
         status.run()
 

=== modified file 'status.py'
--- status.py	2007-05-14 10:54:40 +0000
+++ status.py	2008-04-16 00:00:41 +0000
@@ -24,15 +24,19 @@
 
 class StatusDialog(gtk.Dialog):
     """ Display Status window and perform the needed actions. """
-    def __init__(self, wt, wtpath):
+    def __init__(self, wt, wtpath, revision=None):
         """ Initialize the Status window. """
         super(StatusDialog, self).__init__(flags=gtk.DIALOG_MODAL, buttons=(gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))
         self.set_title("Working tree changes")
         self._create()
         self.wt = wt
         self.wtpath = wtpath
+        
+        if revision is None:
+            revision = self.wt.branch.last_revision()
+            
         # Set the old working tree
-        self.old_tree = self.wt.branch.repository.revision_tree(self.wt.branch.last_revision())
+        self.old_tree = self.wt.branch.repository.revision_tree(revision)
         # Generate status output
         self._generate_status()
 

